/*
 * This program is Copyright 1998 by Henry Cohen commercial rights are reserved.
 * The program is provided as is with no warranties of any sort including 
 * fitness for any purpose.  In no case will the author be held liable for
 * damages related to the use of this program.

 * The author hereby grants rights to use, copy, modify and create derived
 * products for individual, non-commercial purposes provided a copy of this
 * notice is included.  Any commercial use requires the written approval of 
 * the author.
 * Henry Cohen 1998.
 */

package jdic;
import java.awt.*;
import java.awt.event.*;

/*
 * Hyouji Panel is used in a kanjidic lookup to display
 * the selected kanji in individual dialog windows.
 */

class HyoujiPanel extends KanjiPanel {
    Dialog d;
    public HyoujiPanel(String[] kdictEntries){
	super(kdictEntries);
    }
    public void kanjiSelection(String kdictEntry) {

	/*
	 * Find a frame to be parent to this dialog
	 */
	Component c;
	for (c = this.getParent(); 
	     (c!=null)&& !(c instanceof Frame); 
	     c = c.getParent());
	if (c == null) {
	    return;  // This should never happen!
	}
	/* 
	 * This method can be evoked many times within this class.
	 * If it is then the Dialog instance will be overwritten.
	 * We have two choices, easiest is to allow only one dialog
	 * to be present at a time or we can set up a stack or hashtable
	 * or array or something to hold all of the references until they
	 * are disposed of by the user.  I will opt for easy.  Only one
	 * at a time.
	 */
	if (d != null ) d.dispose();
	
	d = new Dialog((Frame)c,kdictEntry.substring(0,1),false);
	d.add(new Kanji(kdictEntry), "Center");
	d.addWindowListener(new WindowAdapter(){
	    public void windowClosing(WindowEvent e){
		d.dispose();
	    }
	});
	d.validate();	
	d.pack();
	d.show();
    }
}
